/*****************************************************************************/
/*   This program is developed by Borland C++ 3.1			      */
/******************************************************************************/
/*  Demo 16: One P180X Card demo.					      */
/*   To estimate the performance for P180X_Do(), P180X_Di() and P180X_Da().   */
/******************************************************************************/
#define  MYLIB
#include <time.h>
#include "P180X.H"

clock_t StartTick,EndTick;
int main()
{
   int	   i,j;
   WORD    wBoards,wRetVal;
   WORD    wDIOdata,wOutput;
   float   fSeconds,fMHz;
   DWORD   dwI;
   WORD    wAddrTimer,wAddrCtrl,wAddrDio,wAddrAdda;

   clrscr();

   /* initiaing P180X card and detect how many P180X card in PC */
   wRetVal=P180X_DriverInit(&wBoards);
   printf("Threr are %d P180X Cards in this PC\n",wBoards);

   if( wBoards==0 )
   {
      putch(0x07);  putch(0x07);  putch(0x07);
      printf("There are no P180X card in this PC !!!\n");
      exit(0);
   }

   /* dump every P180X card's configuration address space */
   printf("The Configuration Space ->   Timer   Control   DIO    AD/DA\n");
   for(i=0; i<wBoards; i++)
   {
      P180X_GetConfigAddressSpace(i,&wAddrTimer,&wAddrCtrl,&wAddrDio,&wAddrAdda);
      printf("Card %02d:  Timer:%04xH  Ctrl:%04xH  Dio:%04xH  Adda:%04xH\n",
				     i,wAddrTimer,wAddrCtrl,wAddrDio,wAddrAdda);
   }

   P180X_ActiveBoard( 0 );
   StartTick=clock();
   i=0;
   printf("Estimating the performance of P180X_Do(), please waiting...\n");
   for(dwI=0; dwI<1000000L; dwI++)
   {
      P180X_Do(wOutput);     /* Digital output */
   }
   EndTick=clock();
   fSeconds=(EndTick-StartTick)/CLK_TCK;
   fMHz=1.0/fSeconds;
   printf("StartTick:%ld   EndTick=%d\n",StartTick,EndTick);
   printf("It takes %5.3f second to run 1,000,000 times P180X_Do() !!!\n",fSeconds);
   printf("The performance of P180X_Do() is %5.2f MHz.\n",fMHz);
   printf("\n");

   StartTick=clock();
   printf("Estimating the performance of P180X_Di(), please waiting...\n");
   for(dwI=0; dwI<1000000L; dwI++)
   {
      P180X_Di(&wDIOdata);     /* Digital output */
   }
   EndTick=clock();
   fSeconds=(EndTick-StartTick)/CLK_TCK;
   fMHz=1.0/fSeconds;
   printf("StartTick:%ld   EndTick=%d\n",StartTick,EndTick);
   printf("It takes %5.3f second to run 1,000,000 times P180X_Di() !!!\n",fSeconds);
   printf("The performance of P180X_Di() is %5.2f MHz.\n",fMHz);
   printf("\n");

   StartTick=clock();
   printf("Estimating the performance of P180X_Da(), please waiting...\n");
   for(dwI=0; dwI<1000000L; dwI++)
   {
      P180X_Da(0,0x900);   /* DA CH:0 output 0x900 */
   }
   EndTick=clock();
   fSeconds=(EndTick-StartTick)/CLK_TCK;
   fMHz=1.0/fSeconds;
   printf("StartTick:%ld   EndTick=%d\n",StartTick,EndTick);
   printf("It takes %5.3f second to run 1,000,000 times P180X_Da() !!!\n",fSeconds);
   printf("The performance of P180X_Da() is %5.2f MHz.\n",fMHz);
   printf("\n");

   P180X_DriverClose();
   return 0;
}
