/**********************************************************************/
/*   This program is developed by Borland C++ 3.1		       */
/***********************************************************************/
/*  Demo 18: One P180X Card MagicScan Function demo.		       */
/*    To acquire all A/D channels, then display the CH:0, CH:1, CH:15, */
/*    CH:16 and CH:17's data for those channels.                       */
/***********************************************************************/
#define  MYLIB
#include <graphics.h>
#include "P180X.H"

#define  DATACOUNT  100    /* how many data is scan for a A/D channel */

WORD   wDaNum=90,wAdClk=24;

WORD   wV[32][DATACOUNT];  /* AD CH:0-31 Buffer */

WORD   wPlot0[500]; /* transformed into wave form */
int main()
{
   WORD    i,j;
   WORD    wBoards,wRetVal;
   WORD    wDIOdata;
   float   fVal;
   char    cShow[80];
   WORD    wAddrTimer,wAddrCtrl,wAddrDio,wAddrAdda;

   clrscr();

   /* initiaing P180X card and detect how many P180X card in PC */
   wRetVal=P180X_DriverInit(&wBoards);
   printf("Threr are %d P180X Cards in this PC\n",wBoards);

   if( wBoards==0 )
   {
      putch(0x07);  putch(0x07);  putch(0x07);
      printf("There are no P180X card in this PC !!!\n");
      exit(0);
   }

   /* dump every P180X card's configuration address space */
   printf("The Configuration Space ->   Timer   Control   DIO    AD/DA\n");
   for(i=0; i<wBoards; i++)
   {
      P180X_GetConfigAddressSpace(i,&wAddrTimer,&wAddrCtrl,&wAddrDio,&wAddrAdda);
      printf("Card %02d:  Timer:%04xH  Ctrl:%04xH  Dio:%04xH  Adda:%04xH\n",
				     i,wAddrTimer,wAddrCtrl,wAddrDio,wAddrAdda);
   }

   /* The P180X_ActiveBoard() function must be used to active a board, */
   /* then all operation will take effect to the actived board.        */

   printf("--------------------------------------------------\n");
   printf("Now Active First P180X Card...\n");
   P180X_ActiveBoard( 0 );

   P180X_Do(0x1234);	 /* Digital output */
   P180X_Di(&wDIOdata);  /* Digital input  */
   printf("Digital Output -> 1234H  |  Digital Input -> %04xH\n",wDIOdata);
   printf("\nHit any key to show wave form.\n");
   getch();

   graphic_init();
   cleardevice();
   setcolor(RED);

   for (i=0; i<DATACOUNT; i++)
   {
      wV[4][i]=0;
      wV[3][i]=0;
      wV[5][i]=0;
      wV[20][i]=0;
      wV[17][i]=0;
   }

   wRetVal=P180X_ClearScan();
   wRetVal += P180X_AddToScan(0,0,1,0,0,0);  /* CH:0 */
   wRetVal += P180X_SaveScan(0,wV[0]);

   wRetVal += P180X_AddToScan(1,0,1,0,0,0);  /* CH:1 */
   wRetVal += P180X_SaveScan(1,wV[1]);

   wRetVal += P180X_AddToScan(2,0,1,0,0,0);  /* CH:2 */
   wRetVal += P180X_SaveScan(2,wV[2]);

   wRetVal += P180X_AddToScan(3,0,1,0,0,0);  /* CH:3 */
   wRetVal += P180X_SaveScan(3,wV[3]);

   wRetVal += P180X_AddToScan(4,0,1,0,0,0);  /* CH:4 */
   wRetVal += P180X_SaveScan(4,wV[4]);

   wRetVal += P180X_AddToScan(5,0,1,0,0,0);  /* CH:5 */
   wRetVal += P180X_SaveScan(5,wV[5]);

   wRetVal += P180X_AddToScan(6,0,1,0,0,0);  /* CH:6 */
   wRetVal += P180X_SaveScan(6,wV[6]);

   wRetVal += P180X_AddToScan(7,0,1,0,0,0);  /* CH:7 */
   wRetVal += P180X_SaveScan(7,wV[7]);

   wRetVal += P180X_AddToScan(8,0,1,0,0,0);  /* CH:8 */
   wRetVal += P180X_SaveScan(8,wV[8]);

   wRetVal += P180X_AddToScan(9,0,1,0,0,0);  /* CH:9 */
   wRetVal += P180X_SaveScan(9,wV[9]);

   wRetVal += P180X_AddToScan(10,0,1,0,0,0); /* CH:10 */
   wRetVal += P180X_SaveScan(10,wV[10]);

   wRetVal += P180X_AddToScan(11,0,1,0,0,0); /* CH:11 */
   wRetVal += P180X_SaveScan(11,wV[11]);

   wRetVal += P180X_AddToScan(12,0,1,0,0,0); /* CH:12 */
   wRetVal += P180X_SaveScan(12,wV[12]);

   wRetVal += P180X_AddToScan(13,0,1,0,0,0); /* CH:13 */
   wRetVal += P180X_SaveScan(13,wV[13]);

   wRetVal += P180X_AddToScan(14,0,1,0,0,0); /* CH:14 */
   wRetVal += P180X_SaveScan(14,wV[14]);

   wRetVal += P180X_AddToScan(15,0,1,0,0,0); /* CH:15 */
   wRetVal += P180X_SaveScan(15,wV[15]);

   wRetVal += P180X_AddToScan(16,0,1,0,0,0); /* CH:16 */
   wRetVal += P180X_SaveScan(16,wV[16]);

   wRetVal += P180X_AddToScan(17,0,1,0,0,0); /* CH:17 */
   wRetVal += P180X_SaveScan(17,wV[17]);

   wRetVal += P180X_AddToScan(18,0,1,0,0,0); /* CH:18 */
   wRetVal += P180X_SaveScan(18,wV[18]);

   wRetVal += P180X_AddToScan(19,0,1,0,0,0); /* CH:19 */
   wRetVal += P180X_SaveScan(19,wV[19]);

   wRetVal += P180X_AddToScan(20,0,1,0,0,0); /* CH:20 */
   wRetVal += P180X_SaveScan(20,wV[20]);

   wRetVal += P180X_AddToScan(21,0,1,0,0,0); /* CH:21 */
   wRetVal += P180X_SaveScan(21,wV[21]);

   wRetVal += P180X_AddToScan(22,0,1,0,0,0); /* CH:22 */
   wRetVal += P180X_SaveScan(22,wV[22]);

   wRetVal += P180X_AddToScan(23,0,1,0,0,0); /* CH:23 */
   wRetVal += P180X_SaveScan(23,wV[23]);

   wRetVal += P180X_AddToScan(24,0,1,0,0,0); /* CH:24 */
   wRetVal += P180X_SaveScan(24,wV[24]);

   wRetVal += P180X_AddToScan(25,0,1,0,0,0); /* CH:25 */
   wRetVal += P180X_SaveScan(25,wV[25]);

   wRetVal += P180X_AddToScan(26,0,1,0,0,0); /* CH:26 */
   wRetVal += P180X_SaveScan(26,wV[26]);

   wRetVal += P180X_AddToScan(27,0,1,0,0,0); /* CH:27 */
   wRetVal += P180X_SaveScan(27,wV[27]);

   wRetVal += P180X_AddToScan(28,0,1,0,0,0); /* CH:28 */
   wRetVal += P180X_SaveScan(28,wV[28]);

   wRetVal += P180X_AddToScan(29,0,1,0,0,0); /* CH:29 */
   wRetVal += P180X_SaveScan(29,wV[29]);

   wRetVal += P180X_AddToScan(30,0,1,0,0,0); /* CH:30 */
   wRetVal += P180X_SaveScan(30,wV[30]);

   wRetVal += P180X_AddToScan(31,0,1,0,0,0); /* CH:31 */
   wRetVal += P180X_SaveScan(31,wV[31]);

   wRetVal=P180X_StartScan(200,DATACOUNT);
   if(wRetVal==0)
   {
      sprintf(cShow,"1st Card: P180X_StartScan OK.");
      outtextxy(10,10,cShow);
   }
   else
   {
      cleardevice();
      closegraph();
      putch(0x07);
      printf("1st Card: P180X_StartScan Error !!!, return=%x\n\n",wRetVal);
      exit(0);
   }

   sprintf(cShow,"Channel 0's wave form:");
   outtextxy(10,30,cShow);
   for(i=0; i<DATACOUNT; i++)	  /* channel 0's data and its wave form */
      wPlot0[i]=30+(wV[0][i]/36);
   for(i=0; i<DATACOUNT-1; i++)   /* plot channel 0's wave form */
      line(10+i,wPlot0[i],10+i+1,wPlot0[i+1]);

   sprintf(cShow,"Channel 1's wave form:");
   outtextxy(10,130,cShow);
   for(i=0; i<DATACOUNT; i++)  /* channel 1's data and its wave form */
      wPlot0[i]=130+(wV[1][i]/36);
   for(i=0; i<DATACOUNT-1; i++)  /* plot channel 1's wave form */
      line(10+i,wPlot0[i],10+i+1,wPlot0[i+1]);

   sprintf(cShow,"Channel 15's wave form:");
   outtextxy(10,230,cShow);
   for(i=0; i<DATACOUNT; i++)  /* channel 15's data and its wave form */
      wPlot0[i]=230+(wV[15][i]/36);
   for(i=0; i<DATACOUNT-1; i++)  /* plot channel 15's wave form */
      line(10+i,wPlot0[i],10+i+1,wPlot0[i+1]);


   sprintf(cShow,"Channel 16's wave form:");
   outtextxy(300,30,cShow);
   for(i=0; i<DATACOUNT; i++)  /* channel 16's data and its wave form */
      wPlot0[i]=30+(wV[16][i]/36);
   for(i=0; i<DATACOUNT-1; i++)  /* plot channel 16's wave form */
      line(300+i,wPlot0[i],300+i+1,wPlot0[i+1]);


   sprintf(cShow,"Channel 17's wave form:");
   outtextxy(300,130,cShow);
   for(i=0; i<DATACOUNT; i++)  /* channel 17's data and its wave form */
      wPlot0[i]=130+(wV[17][i]/36);
   for(i=0; i<DATACOUNT-1; i++)  /* plot channel 17's wave form */
      line(300+i,wPlot0[i],300+i+1,wPlot0[i+1]);

   getch();
   cleardevice();
   closegraph();

   P180X_DriverClose();
   return 0;
}

graphic_init()
{
   int driver,mode,char_size;

   driver=EGA;
   mode=EGAHI;
   initgraph(&driver,&mode,"");
   setactivepage(0);
   setvisualpage(0);
   setcolor(0);
   setbkcolor(15);
   settextstyle(SMALL_FONT,HORIZ_DIR,6);
   return 0;
}

