/**********************************************************************/
/*   This program is developed by Microsoft C 5.1		       */
/***********************************************************************/
/*  Demo 1: One P180X Card demo.				       */
/*    Basic operation onto P180X card.				       */
/*    => P180X_Init(), P180X_ActiveBoard(), P180X_Di(), P180X_Do()     */
/***********************************************************************/
#define  MYLIB
#include "P180X.H"

int main()
{
   int	   i,j;
   WORD    wBoards,wRetVal,wVal;
   WORD    wDIOdata;
   float   fVal,fAdVals[5];
   short   nVal;
   WORD   wAddrTimer,wAddrCtrl,wAddrDio,wAddrAdda;

   clrscr();  // a clear screen function in P180XMC?.LIB
   gotoxy(1,1);

   /* initiaing P180X card and detect how many P180X card in PC */
   wRetVal=P180X_DriverInit(&wBoards);
   printf("Threr are %d P180X Cards in this PC\n",wBoards);

   if( wBoards==0 )
   {
      putch(0x07);  putch(0x07);  putch(0x07);
      printf("There are no P180X card in this PC !!!\n");
      exit(0);
   }

   /* dump every P180X card's configuration address space */
   printf("The Configuration Space ->   Timer   Control   DIO    AD/DA\n");
   for(i=0; i<wBoards; i++)
   {
      P180X_GetConfigAddressSpace(i,&wAddrTimer,&wAddrCtrl,&wAddrDio,&wAddrAdda);
      printf("Card %02d:  Timer:%04xH  Ctrl:%04xH  Dio:%04xH  Adda:%04xH\n",
				     i,wAddrTimer,wAddrCtrl,wAddrDio,wAddrAdda);
   }

   /* Getting the Driver version */
   wRetVal=P180X_GetDriverVersion(&wVal);
   printf("Driver Version=%x\n",wVal);

   /* call a function to test if exact calling LIB */
   nVal=P180X_ShortSub2(1,2);
   printf("P180X_ShortSub2(1,2) = %d\n",nVal);

   /* call another function to test if exact calling LIB */
   fVal=P180X_FloatSub2(1.0,2.0);
   printf("P180X_FloatSub2(1.0,2.0) = %f\n",fVal);

   /***
    The P180X_ActiveBoard() function must be used to active a board,
    then all operation will take effect to the actived board.
   ***/

   printf("--------------------------------------------------\n");
   printf("Now Active First P180X Card...\n");
   P180X_ActiveBoard( 0 );

   P180X_Do(0x55aa);	 /* Digital output */
   P180X_Di(&wDIOdata);  /* Digital input  */
   printf("Digital Output -> 55aaH  |  Digital Input -> %04xH\n",wDIOdata);

   wRetVal=P180X_Da(0,0x900);	/* DA CH:0 output 0x900 */
   if(wRetVal==0)
      printf("DA CH:0 output 0x900.\n");
   else
   {
      putch(0x07); putch(0x07); putch(0x07);
      printf("DA CH:0 Error !!!\n");
      exit(0);
   }

   wRetVal=P180X_Da(1,0xA00);  /* DA CH:1 output 0xA00 */
   if(wRetVal==0)
      printf("DA CH:1 output 0xA00.\n");
   else
   {
      putch(0x07); putch(0x07); putch(0x07);
      printf("DA CH:1 Error !!!\n");
      exit(0);
   }

// wRetVal=P180X_SetChannelConfig(0,0x00); // +/- 5V range for PCI-180XL
// wRetVal+=P180X_DelayUs(3);  //  3 us settling time for PCI-180XL
   wRetVal=P180X_SetChannelConfig(0,0x10); // +/- 5V range for PCI-180XH
   wRetVal+=P180X_DelayUs(23); // 23 us settling time for PCI-180XH
   wRetVal+=P180X_AdPolling(&fVal);
   if (wRetVal==0)
      printf("(5.0V Range) AdPolling CH:0 -> %5.3f\n",fVal);
   else
   {
      putch(0x07); putch(0x07); putch(0x07);
      printf("(5.0V Range) AdPolling CH:0 Error !!!\n");
      exit(0);
   }

   /*--------------- CH:1---------------------------*/
// wRetVal=P180X_SetChannelConfig(1,0x00); // +/- 5V range for PCI-180XL
// wRetVal+=P180X_DelayUs(3);  //  3 us settling time for PCI-180XL
   wRetVal=P180X_SetChannelConfig(1,0x10); // +/- 5V range for PCI-180XH
   wRetVal+=P180X_DelayUs(23); // 23 us settling time for PCI-180XH
   wRetVal+=P180X_AdPolling(&fVal);
   if (wRetVal==0)
      printf("(5.0V Range) AdPolling CH:1 -> %5.3f\n",fVal);
   else
   {
      putch(0x07); putch(0x07); putch(0x07);
      printf("(5.0V Range) AdPolling CH:1 Error !!!\n");
      exit(0);
   }

   // wRetVal=P180X_SetChannelConfig(0,0x00); // +/- 5V range for PCI-180XL
      wRetVal=P180X_SetChannelConfig(0,0x10); // +/- 5V range for PCI-180XH
   // wRetVal+=P180X_DelayUs(3);  //  3 us settling time for PCI-180XL
      wRetVal+=P180X_DelayUs(23); // 23 us settling time for PCI-180XH
      wRetVal=P180X_AdsPolling(fAdVals,5);  /* reading 5 A/D values		  */
      gotoxy(2,18);
      printf("P180X_AdsPolling() ==> 0:[%5.3f] 1:[%5.3f] 2:[%5.3f] 3:[%5.3f] 4:[%5.3f]\n",fAdVals[0],
			      fAdVals[1],fAdVals[2],fAdVals[3],fAdVals[4]);

      for(j=0; j<5; j++)  fAdVals[j]=-100.0;

   // wRetVal=P180X_SetChannelConfig(0,0x00); // +/- 5V range for PCI-180XL
      wRetVal=P180X_SetChannelConfig(0,0x10); // +/- 5V range for PCI-180XH
   // wRetVal+=P180X_DelayUs(3);  //  3 us settling time for PCI-180XL
      wRetVal+=P180X_DelayUs(23); // 23 us settling time for PCI-180XH
      wRetVal=P180X_AdsPacer(fAdVals,5,80); /* reading 5 A/D values with sampling  */
					    /* rate 8M/80=100K			   */
      gotoxy(2,19);
      printf("P180X_AdsPacer()   ==> 0:[%5.3f] 1:[%5.3f] 2:[%5.3f] 3:[%5.3f] 4:[%5.3f]\n",fAdVals[0],
			      fAdVals[1],fAdVals[2],fAdVals[3],fAdVals[4]);


   P180X_DriverClose();
   return 0;
}

