/***********************************************************************/
/*   This program is developed by Microsoft C 5.1			*/
/************************************************************************/
/*  Demo 11: One P180X Card MagicScan Function demo.			*/
/*  First Card:  To acquire A/D CH:0, CH:1 250 times.			*/
/************************************************************************/
#define  MYLIB
#include "P180X.H"

#define  DATACOUNT  250  // how many data is scan for a A/D channel

WORD   wAdClk=24;	// A/D sampling rate is 8M/wAdClk
WORD   wV0[DATACOUNT];	// AD ch:0 buffer
WORD   wV1[DATACOUNT];	// AD ch:1 buffer

WORD   wPlot0[500]; //	transformed into wave form
int main()
{
   WORD    i,j;
   WORD    wBoards,wRetVal;
   WORD    wDIOdata;
   float   fVal;
   char    cShow[80];
   WORD    wAddrTimer,wAddrCtrl,wAddrDio,wAddrAdda;

   clrscr();  // a clear screen function in P180XMC?.LIB
   gotoxy(1,1);

   // initiaing P180X card and detect how many P180X card in PC
   wRetVal=P180X_DriverInit(&wBoards);
   printf("Threr are %d P180X Cards in this PC\n",wBoards);

   if( wBoards==0 )
   {
      putch(0x07);  putch(0x07);  putch(0x07);
      printf("There are no P180X card in this PC !!!\n");
      exit(0);
   }

   /* dump every P180X card's configuration address space */
   printf("The Configuration Space ->   Timer   Control   DIO    AD/DA\n");
   for(i=0; i<wBoards; i++)
   {
      P180X_GetConfigAddressSpace(i,&wAddrTimer,&wAddrCtrl,&wAddrDio,&wAddrAdda);
      printf("Card %02d:  Timer:%04xH  Ctrl:%04xH  Dio:%04xH  Adda:%04xH\n",
				     i,wAddrTimer,wAddrCtrl,wAddrDio,wAddrAdda);
   }

   // The P180X_ActiveBoard() function must be used to active a board,
   // then all operation will take effect to the actived board.

   printf("--------------------------------------------------\n");
   printf("Now Active First P180X Card...\n");
   P180X_ActiveBoard( 0 );

   P180X_Do(0x1234);	 // Digital output
   P180X_Di(&wDIOdata);  // Digital input
   printf("Digital Output -> 1234H  |  Digital Input -> %04xH\n",wDIOdata);

   for (i=0; i<DATACOUNT; i++)	 wV0[i]=wV1[i]=0;
   wRetVal=P180X_ClearScan();
   wRetVal += P180X_AddToScan(0,0,1,0,0,0);
   wRetVal += P180X_SaveScan(0,wV0);
   wRetVal += P180X_AddToScan(1,0,1,0,0,0);
   wRetVal += P180X_SaveScan(1,wV1);
   wRetVal=P180X_StartScan(24,DATACOUNT);
   if(wRetVal==0)
   {
      printf("1st Card: P180X_StartScan OK.\n");
      printf("Channel 0's data:\n");
      printf("[ 0]=%04xH, [ 1]=%04xH, [ 2]=%04xH, [ 3]=%04xH\n",
	   wV0[0],wV0[1],wV0[2],wV0[3]);
      printf("[ 4]=%04xH, [ 5]=%04xH, [ 6]=%04xH, [ 7]=%04xH\n",
	   wV0[4],wV0[5],wV0[6],wV0[7]);
      printf("[ 8]=%04xH, [ 9]=%04xH, [10]=%04xH, [11]=%04xH\n",
	   wV0[8],wV0[9],wV0[10],wV0[11]);
      printf("[12]=%04xH, [13]=%04xH, [14]=%04xH, [15]=%04xH\n",
	   wV0[12],wV0[13],wV0[14],wV0[15]);
      printf("[16]=%04xH, [17]=%04xH, [18]=%04xH, [19]=%04xH\n",
	   wV0[16],wV0[17],wV0[18],wV0[19]);

      printf("Channel 1's data:\n");
      printf("[ 0]=%04xH, [ 1]=%04xH, [ 2]=%04xH, [ 3]=%04xH\n",
	   wV1[0],wV1[1],wV1[2],wV1[3]);
      printf("[ 4]=%04xH, [ 5]=%04xH, [ 6]=%04xH, [ 7]=%04xH\n",
	   wV1[4],wV1[5],wV1[6],wV1[7]);
      printf("[ 8]=%04xH, [ 9]=%04xH, [10]=%04xH, [11]=%04xH\n",
	   wV1[8],wV1[9],wV1[10],wV1[11]);
      printf("[12]=%04xH, [13]=%04xH, [14]=%04xH, [15]=%04xH\n",
	   wV1[12],wV1[13],wV1[14],wV1[15]);
      printf("[16]=%04xH, [17]=%04xH, [18]=%04xH, [19]=%04xH\n",
	   wV1[16],wV1[17],wV1[18],wV1[19]);
   }
   else
   {
      putch(0x07);
      printf("1st Card: P180X_StartScan Error !!!, return=%x\n\n",wRetVal);
      exit(0);
   }

   P180X_DriverClose();
   return 0;
}

