/**********************************************************************/
/*   This program is developed by Turbo C 2.0			       */
/***********************************************************************/
/*  Demo 12: Two P180X Cards MagicScan Function demo.		       */
/*  First  Card: To acquire A/D CH:0, CH:1 250 times.		       */
/*  Second Card: To acquire A/D CH:0, CH:1 250 times.		       */
/***********************************************************************/
#define  MYLIB
#include "P180X.H"

#define  DATACOUNT  250

WORD   wDaNum=90,wAdClk=24;
WORD   wV0[DATACOUNT];	/* AD ch:0 buffer */
WORD   wV1[DATACOUNT];	/* AD ch:1 buffer */

WORD   wPlot0[DATACOUNT]; /* transformed into wave form */
int main()
{
   WORD    i,j;
   WORD    wBoards,wRetVal;
   WORD    wDIOdata;
   float   fVal;
   char    cShow[80];
   WORD    wAddrTimer,wAddrCtrl,wAddrDio,wAddrAdda;
   DWORD   dwHiAlarm,dwLoAlarm;

   clrscr();

   /* initiaing P180X card and detect how many P180X card in PC */
   wRetVal=P180X_DriverInit(&wBoards);
   printf("Threr are %d P180X Cards in this PC\n",wBoards);

   if( wBoards<=1 )
   {
      putch(0x07);  putch(0x07);  putch(0x07);
      printf("Please install two P180X cards in this PC !!!\n");
      exit(0);
   }

   /* dump every P180X card's configuration address space */
   printf("The Configuration Space ->   Timer   Control   DIO    AD/DA\n");
   for(i=0; i<wBoards; i++)
   {
      P180X_GetConfigAddressSpace(i,&wAddrTimer,&wAddrCtrl,&wAddrDio,&wAddrAdda);
      printf("Card %02d:  Timer:%04xH  Ctrl:%04xH  Dio:%04xH  Adda:%04xH\n",
				     i,wAddrTimer,wAddrCtrl,wAddrDio,wAddrAdda);
   }

   /* The P180X_ActiveBoard() function must be used to active a board, */
   /* then all operation will take effect to the actived board.        */

   printf("--------------------------------------------------\n");
   printf("Now Active First P180X Card...\n");
   P180X_ActiveBoard( 0 );

   P180X_Do(0x1234);	 /* Digital output */
   P180X_Di(&wDIOdata);  /* Digital input  */
   printf("Digital Output -> 1234H  |  Digital Input -> %04xH\n",wDIOdata);

   printf("--------------------------------------------------\n");
   printf("Now Active Second P180X Card...\n");
   P180X_ActiveBoard( 1 );

   P180X_Do(0x5678);	 /* Digital output */
   P180X_Di(&wDIOdata);  /* Digital input  */
   printf("Digital Output -> 5678H  |  Digital Input -> %04xH\n",wDIOdata);
   printf("\nHit any key to show wave form.\n");
   getch();

   /***************************************************************/
   graphic_init();
   cleardevice();
   setcolor(RED);

   /* To active the first card */
   P180X_ActiveBoard( 0 );
   for (i=0; i<DATACOUNT; i++)	 wV0[i]=wV1[i]=0;
   wRetVal=P180X_ClearScan();
   wRetVal += P180X_AddToScan(0,0,1,0,0,0);
   wRetVal += P180X_SaveScan(0,wV0);
   wRetVal += P180X_AddToScan(1,0,1,0,0,0);
   wRetVal += P180X_SaveScan(1,wV1);
   wRetVal=P180X_StartScan(24,DATACOUNT);
   if(wRetVal==0)
   {
      sprintf(cShow,"1st Card: P180X_StartScan OK.");
      outtextxy(10,10,cShow);
      sprintf(cShow,"dwHiAlarm=%08x  dwLoAlarm=%08x.",dwHiAlarm,dwLoAlarm);
      outtextxy(10,25,cShow);
   }
   else
   {
      cleardevice();
      closegraph();
      putch(0x07);
      printf("1st Card: P180X_StartScan Error !!!, return=%x\n\n",wRetVal);
      exit(0);
   }

   sprintf(cShow,"Channel 0's wave form:");
   outtextxy(10,50,cShow);
   for(i=0; i<DATACOUNT; i++)  /* channel 0's data and its wave form */
      wPlot0[i]=30+(wV0[i]/36);
   for(i=0; i<DATACOUNT-1; i++)  /* plot channel 0's wave form */
      line(10+i,wPlot0[i],10+i+1,wPlot0[i+1]);

   sprintf(cShow,"Channel 1's wave form:");
   outtextxy(10,170,cShow);
   for(i=0; i<DATACOUNT; i++)  /* channel 1's data and its wave form */
      wPlot0[i]=200+(wV1[i]/36);
   for(i=0; i<DATACOUNT-1; i++)  /* plot channel 0's wave form */
      line(10+i,wPlot0[i],10+i+1,wPlot0[i+1]);

   /*-----------------------------------------------------------------*/
   /* To active the second card */
   P180X_ActiveBoard( 1 );

   for (i=0; i<DATACOUNT; i++)	 wV0[i]=wV1[i]=0;
   wRetVal=P180X_ClearScan();
   wRetVal += P180X_AddToScan(0,0,1,0,0,0);
   wRetVal += P180X_SaveScan(0,wV0);
   wRetVal += P180X_AddToScan(1,0,1,0,0,0);
   wRetVal += P180X_SaveScan(1,wV1);
   wRetVal=P180X_StartScan(24,DATACOUNT);
   if(wRetVal==0)
   {
      sprintf(cShow,"2st Card: P180X_StartScan OK.");
      outtextxy(300,10,cShow);
      sprintf(cShow,"dwHiAlarm=%08x  dwLoAlarm=%08x.",dwHiAlarm,dwLoAlarm);
      outtextxy(300,25,cShow);
   }
   else
   {
      cleardevice();
      closegraph();
      putch(0x07);
      printf("1st Card: P180X_StartScan Error !!!, return=%x\n\n",wRetVal);
      exit(0);
   }

   sprintf(cShow,"Channel 0's wave form:");
   outtextxy(300,50,cShow);
   for(i=0; i<DATACOUNT; i++)  /* channel 0's data and its wave form */
      wPlot0[i]=30+(wV0[i]/36);
   for(i=0; i<DATACOUNT-1; i++)  /* plot channel 0's wave form       */
      line(300+i,wPlot0[i],300+i+1,wPlot0[i+1]);

   sprintf(cShow,"Channel 1's wave form:");
   outtextxy(300,170,cShow);
   for(i=0; i<DATACOUNT; i++)  /* channel 1's data and its wave form */
      wPlot0[i]=200+(wV1[i]/36);
   for(i=0; i<DATACOUNT-1; i++)  /* plot channel 0's wave form       */
      line(300+i,wPlot0[i],300+i+1,wPlot0[i+1]);

   getch();
   cleardevice();
   closegraph();

   P180X_DriverClose();
   return 0;
}

graphic_init()
{
   int driver,mode,char_size;

   driver=EGA;
   mode=EGAHI;
   initgraph(&driver,&mode,"");
   setactivepage(0);
   setvisualpage(0);
   setcolor(0);
   setbkcolor(15);
   settextstyle(SMALL_FONT,HORIZ_DIR,6);
   return 0;
}

