/**********************************************************************/
/*   This program is developed by Turbo C 2.0			       */
/*   For  PCI-180XH						       */
/***********************************************************************/
/*  Demo 29: One P180X Card MagicScan Function demo.		       */
/*  First Card:  To acquire A/D CH:2, CH:3, CH:4 250 times.	       */
/*  The sampling rate is 8M/wFreqDiv				       */
/***********************************************************************/
#define  MYLIB
#include "P180X.H"

#define  DATACOUNT  250

WORD   wDaNum=90,wAdClk=24;
WORD   wV2[DATACOUNT];	/* AD ch:2 buffer */
WORD   wV3[DATACOUNT];	/* AD ch:3 buffer */
WORD   wV4[DATACOUNT];	/* AD ch:4 buffer */

WORD   wPlot2[500];  /* transformed into wave form */
WORD   wPlot3[500];  /* transformed into wave form */
WORD   wPlot4[500];  /* transformed into wave form */
WORD   old_wPlot2[500];  /* transformed into wave form */
WORD   old_wPlot3[500];  /* transformed into wave form */
WORD   old_wPlot4[500];  /* transformed into wave form */
int main()
{
   WORD    i,j;
   WORD    wBoards,wRetVal,wFreqDiv;
   WORD    wDIOdata;
   float   fVal;
   char    ch,cShow[80];
   WORD   wAddrTimer,wAddrCtrl,wAddrDio,wAddrAdda;

   clrscr();

   /* initiaing P180X card and detect how many P180X card in PC */
   wRetVal=P180X_DriverInit(&wBoards);
   printf("Threr are %d P180X Cards in this PC\n",wBoards);

   if( wBoards==0 )
   {
      putch(0x07);  putch(0x07);  putch(0x07);
      printf("There are no P180X card in this PC !!!\n");
      exit(0);
   }

   /* dump every P180X card's configuration address space */
   printf("The Configuration Space ->   Timer   Control   DIO    AD/DA\n");
   for(i=0; i<wBoards; i++)
   {
      P180X_GetConfigAddressSpace(i,&wAddrTimer,&wAddrCtrl,&wAddrDio,&wAddrAdda);
      printf("Card %02d:  Timer:%04xH  Ctrl:%04xH  Dio:%04xH  Adda:%04xH\n",
				     i,wAddrTimer,wAddrCtrl,wAddrDio,wAddrAdda);
   }

   /* The P180X_ActiveBoard() function must be used to active a board, */
   /* then all operation will take effect to the actived board.        */

   printf("--------------------------------------------------\n");
   printf("Now Active First P180X Card...\n");
   P180X_ActiveBoard( 0 );

   P180X_Do(0x1234);	 /* Digital output */
   P180X_Di(&wDIOdata);  /* Digital input  */
   printf("Digital Output -> 1234H  |  Digital Input -> %04xH\n",wDIOdata);
   printf("\nPlease Enter the Freq Divisior(8000): ");
   scanf("%d",&wFreqDiv);


   graphic_init();
   cleardevice();

   sprintf(cShow,"MagicScan() testing    Sampling Rate:%.2f KHz",
						  8000.0/wFreqDiv);
   setcolor(RED);
   outtextxy(120,10,cShow);

   for (i=0; i<DATACOUNT; i++)
   {
       wV2[i]=wV3[i]=wV4[i]=0;
       old_wPlot2[i]=old_wPlot3[i]=old_wPlot4[i]=0;
       wPlot2[i]=wPlot3[i]=wPlot4[i]=0;
   }

   for(  ;   ; )
   {
      wRetVal=P180X_ClearScan();
      wRetVal += P180X_AddToScan(2,0,1,0,0,0);	/* CH:2 to scan */
      wRetVal += P180X_SaveScan(0,wV2);
      wRetVal += P180X_AddToScan(3,0,1,0,0,0);	/* CH:3 to scan */
      wRetVal += P180X_SaveScan(1,wV3);
      wRetVal += P180X_AddToScan(4,0,1,0,0,0);	/* CH:4 to scan */
      wRetVal += P180X_SaveScan(2,wV4);
      wRetVal=P180X_StartScan(wFreqDiv,DATACOUNT); /* sampling rate 8M/2000 */
      if(wRetVal==0)
      {
	 sprintf(cShow,"1st Card: P180X_StartScan OK.");
	 /* outtextxy(10,10,cShow); */
      }
      else
      {
	 cleardevice();
	 closegraph();
	 putch(0x07);
	 printf("1st Card: P180X_StartScan Error !!!, return=%x\n\n",wRetVal);
	 exit(0);
      }

      setcolor(WHITE);
      for(i=0; i<DATACOUNT-1; i++)  /*** erase the wave form ***/
      {
	 line(10+i,old_wPlot2[i],10+i+1,old_wPlot2[i+1]);
	 line(10+i,old_wPlot3[i],10+i+1,old_wPlot3[i+1]);
	 line(10+i,old_wPlot4[i],10+i+1,old_wPlot4[i+1]);
      }


      setcolor(RED);
      sprintf(cShow,"Channel 2's wave form:");
      outtextxy(10,30,cShow);
      for(i=0; i<DATACOUNT; i++)  /* channel 2's data and its wave form */
	 wPlot2[i]=30+(wV2[i]/36);
      for(i=0; i<DATACOUNT-1; i++)  /* plot channel 2's wave form       */
	 line(10+i,wPlot2[i],10+i+1,wPlot2[i+1]);

      sprintf(cShow,"Channel 3's wave form:");
      outtextxy(10,150,cShow);
      for(i=0; i<DATACOUNT; i++)  /* channel 3's data and its wave form */
	 wPlot3[i]=120+(wV3[i]/36);
      for(i=0; i<DATACOUNT-1; i++)  /* plot channel 3's wave form */
	 line(10+i,wPlot3[i],10+i+1,wPlot3[i+1]);

      sprintf(cShow,"Channel 4's wave form:");
      outtextxy(10,240,cShow);
      for(i=0; i<DATACOUNT; i++)  /* channel 4's data and its wave form */
	 wPlot4[i]=240+(wV4[i]/36);
      for(i=0; i<DATACOUNT-1; i++)  /* plot channel 4's wave form */
	 line(10+i,wPlot4[i],10+i+1,wPlot4[i+1]);

      /***** Restore the wave form *****/
      for(i=0; i<DATACOUNT; i++)
      {
	 old_wPlot2[i]=wPlot2[i];
	 old_wPlot3[i]=wPlot3[i];
	 old_wPlot4[i]=wPlot4[i];
      }

      if( kbhit() )
      {
	 ch=getch(); /*** ESC press ***/
	 if( ch==27 )
	    break;
      }
   }
   cleardevice();
   closegraph();

   P180X_DriverClose();
   return 0;
}

graphic_init()
{
   int driver,mode,char_size;

   driver=EGA;
   mode=EGAHI;
   initgraph(&driver,&mode,"");
   setactivepage(0);
   setvisualpage(0);
   setcolor(0);
   setbkcolor(WHITE);
   settextstyle(SMALL_FONT,HORIZ_DIR,6);
   return 0;
}

